src/main/java/model/Patrocinador.java
package model;

import javax.persistence.Entity;

@Entity
public class Patrocinador extends Pessoa implements IPatrocinador {

	private double verbaAInvestir;

	public double getVerbaAInvestir() {
		return verbaAInvestir;
	}

	public void setVerbaAInvestir(double verbaAInvestir) {
		this.verbaAInvestir = verbaAInvestir;
	}

	public double patrocina(double dinheiroADoar) {
		if (verbaAInvestir < dinheiroADoar)
			return -1;
		else
			return verbaAInvestir -= dinheiroADoar;
	}

}

src/main/java/controller/PatrocinadorBean.java
package controller;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.persistence.EntityManager;

import dao.JPAUtil;
import dao.PatrocinadorDao;
import model.Patrocinador;

@ManagedBean
@ApplicationScoped
public class PatrocinadorBean implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Patrocinador patrocinador = new Patrocinador();
	public List<Patrocinador> patrocinadores = new ArrayList<Patrocinador>();
	public List<Patrocinador> patrocinadorsEncontradas = new ArrayList<Patrocinador>();

	public PatrocinadorBean() {
		this.findAll();
	}

	public void gravar() {
		PatrocinadorDao daoPatrocinador = new PatrocinadorDao();
		daoPatrocinador.adiciona(patrocinador);
		patrocinadores.add(patrocinador);
		patrocinador = new Patrocinador();
	}

	public void remover() {
		PatrocinadorDao daoPatrocinador = new PatrocinadorDao();
		daoPatrocinador.remove(patrocinador.getCpf());
		patrocinadores = daoPatrocinador.listaTodos();
		patrocinador = new Patrocinador();
	}

	public Patrocinador recupera() {
		PatrocinadorDao daoPatrocinador = new PatrocinadorDao();
		Patrocinador patrocinadorEncontrada = daoPatrocinador.buscaPorCPF(patrocinador.getCpf());
		return patrocinadorEncontrada;
	}

	public void findAll() {
		PatrocinadorDao daoPatrocinador = new PatrocinadorDao();
		patrocinadores = daoPatrocinador.listaTodos();
	}

	public void atualizar() {
		PatrocinadorDao daoPeessoa = new PatrocinadorDao();
		daoPeessoa.atualiza(patrocinador);
		patrocinador = new Patrocinador();
		patrocinadores = daoPeessoa.listaTodos();
	}

	public Patrocinador getPatrocinador() {
		return patrocinador;
	}

	public List<Patrocinador> getListaDePatrocinadores() {
		return patrocinadores;
	}
	
	public List<Patrocinador> getListaPatrocinadoresEncontradas(){
		return patrocinadorsEncontradas;
	}

}

src/main/webapp/patrocinador/changeOrDeletePatrocinador.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">
<head>
<title>Patrocinador</title>
</head>
<body>
	<h:form>
		<fieldset>
			<legend>Deletar Patrocinador</legend>
			<h:panelGrid columns="2">
				<h:outputLabel value="CPF: " for="cpf" />
				<h:inputText id="cpf" value="#{patrocinadorBean.patrocinador.cpf}" />
				
				<h:commandButton id="gravar" value="Excluir" action="#{patrocinadorBean.remover}" />
				<h:commandButton id="atualizar" value="Atualizar" action="updatePatrocinador" />
				<h:commandButton action="patrocinador" value="Voltar" />
			</h:panelGrid>
		</fieldset>
	</h:form>
</body>
</html>

src/main/webapp/patrocinador/createPatrocinador.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<head>
<title>Patrocinador</title>
</head>
<body>
	<f:view>
		<h:form>
			<fieldset>
				<legend>Cadastro de patrocinador</legend>
				<h:panelGrid columns="2">
					<h:outputLabel value="Nome: " for="nome" />
					<h:inputText id="nome" value="#{patrocinadorBean.patrocinador.nome}" />
					<h:outputLabel value="CPF: " for="cpf" />
					<h:inputText id="cpf" value="#{patrocinadorBean.patrocinador.cpf}" />
					<h:outputLabel value="Verba Disponível " for="	" />
					<h:inputText id="vebadispo" value="#{patrocinadorBean.patrocinador.verbaAInvestir}" />
					

					<h:commandButton id="gravar" value="Gravar"
						action="#{patrocinadorBean.gravar}" />
					<h:commandButton action="changeOrDeletePatrocinador"
						value="Outras Operações" />
					<h:commandButton action="patrocinador" value="Voltar" />
				</h:panelGrid>
			</fieldset>
		</h:form>
	</f:view>
</body>
</html>

src/main/webapp/patrocinador/patrocinador.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Patrocinador</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="createPatrocinador"
				value="Adicionar patrocinador" />
			<h:commandButton action="changeOrDeletePatrocinador"
				value="Atualizar ou Remover" />
			<h:commandButton action="/pessoa" value="voltar" />
		</h:form>


		<!-- Fazendo aparecer todas as pessoas -->
		<p:dataTable var="patrocinador"
			value="#{patrocinadorBean.listaDePatrocinadores}">
			<p:column headerText="CPF">
				<h:outputText value="#{patrocinador.cpf}" />
			</p:column>

			<p:column headerText="Nome">
				<h:outputText value="#{patrocinador.nome}" />
			</p:column>

			<p:column headerText="Verba disponível para patrocínio">
				<h:outputText value="#{patrocinador.verbaAInvestir}" />
			</p:column>


		</p:dataTable>


	</f:view>
</body>
</html>

src/main/webapp/patrocinador/updatePatrocinador.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">
<head>
<title>Patrocinador</title>
</head>
<body>
	<h:form>
		<fieldset>
			<legend>Atualizar Patrocinador</legend>
			<h:panelGrid columns="2">
				<h:outputLabel value="Nome: " for="nome" />
				<h:inputText id="nome" value="#{patrocinadorBean.patrocinador.nome}" />
				<h:outputLabel value="CPF: " for="cpf" />
				<h:inputText id="cpf" value="#{patrocinadorBean.patrocinador.cpf}" />
				<h:outputLabel value="Verba Disponível " for="	" />
				<h:inputText id="vebadispo"
					value="#{patrocinadorBean.patrocinador.verbaAInvestir}" />

				<h:commandButton id="atualizar" value="Atualizar"
					action="#{patrocinadorBean.atualizar}" />
				<h:commandButton action="patrocinador" value="Voltar" />
			</h:panelGrid>
		</fieldset>
	</h:form>
</body>
</html>